import { fillSingleProject } from '../utils/enrichers.js';
import { writer } from '../writer.js';
const OPERATIONS_FIELDS = ['id', 'action', 'status', 'created_at'];
export const command = 'operations';
export const describe = 'Manage operations';
export const aliases = ['operation'];
export const builder = (argv) => argv
    .usage('$0 operations <sub-command> [options]')
    .options({
    'project-id': {
        describe: 'Project ID',
        type: 'string',
    },
})
    .middleware(fillSingleProject)
    .command('list', 'List operations', (yargs) => yargs, (args) => list(args));
export const handler = (args) => {
    return args;
};
export const list = async (props) => {
    const { data } = await props.apiClient.listProjectOperations({
        projectId: props.projectId,
        limit: props.limit,
    });
    writer(props).end(data.operations, {
        fields: OPERATIONS_FIELDS,
    });
};
