import { writer } from '../writer.js';
const ORG_FIELDS = ['id', 'name'];
export const command = 'orgs';
export const describe = 'Manage organizations';
export const aliases = ['org'];
export const builder = (argv) => {
    return argv.usage('$0 orgs <sub-command> [options]').command('list', 'List organizations', (yargs) => yargs, async (args) => {
        // @ts-expect-error: TODO - Assert `args` is `CommonProps`
        await list(args);
    });
};
export const handler = (args) => {
    return args;
};
const list = async (props) => {
    const out = writer(props);
    const { data: { organizations }, } = await props.apiClient.getCurrentUserOrganizations();
    out.write(organizations, {
        fields: ORG_FIELDS,
        title: 'Organizations',
        emptyMessage: 'You are not a member of any organization.',
    });
    out.end();
};
