import { updateContextFile } from '../context.js';
export const command = 'set-context';
export const describe = 'Set the current context';
export const builder = (argv) => argv.usage('$0 set-context [options]').options({
    'project-id': {
        describe: 'Project ID',
        type: 'string',
    },
    'org-id': {
        describe: 'Organization ID',
        type: 'string',
    },
});
export const handler = (props) => {
    const context = {
        projectId: props.projectId,
        orgId: props.orgId,
    };
    updateContextFile(props.contextFile, context);
};
