const ERROR_MATCHERS = [
    [/^Unknown command: (.*)$/, 'UNKNOWN_COMMAND'],
    [/^Missing required argument: (.*)$/, 'MISSING_ARGUMENT'],
    [/^Failed to open web browser. (.*)$/, 'AUTH_BROWSER_FAILED'],
];
export const matchErrorCode = (message) => {
    if (!message) {
        return 'UNKNOWN_ERROR';
    }
    for (const [matcher, code] of ERROR_MATCHERS) {
        const match = message.match(matcher);
        if (match) {
            return code;
        }
    }
    return 'UNKNOWN_ERROR';
};
