import { format } from 'node:util';
import { isDebug } from './env.js';
export const log = {
    debug: (...args) => {
        if (isDebug()) {
            process.stderr.write(`DEBUG: ${format(...args)}\n`);
        }
    },
    warning: (...args) => {
        process.stderr.write(`WARNING: ${format(...args)}\n`);
    },
    info: (...args) => {
        process.stderr.write(`INFO: ${format(...args)}\n`);
    },
    error: (...args) => {
        process.stderr.write(`ERROR: ${format(...args)}\n`);
    },
};
