# @neondatabase/api-client

## Introduction

The `@neondatabase/api-client` library is a wrapper for the Neon API. It provides a convenient way to interact with the Neon API using TypeScript.

## Installation

You can install the library using `npm` or `yarn`.

`npm`:

```bash
npm install @neondatabase/api-client
```

`yarn`:

```bash
yarn add @neondatabase/api-client
```

## Get Started

To get started with the `@neondatabase/api-client` library, follow these steps:

1. Obtain an API key from the [Developer Settings](https://console.neon.tech/app/settings/api-keys) page in the Neon Console.

2. Click **Generate new API key**.

3. Enter name for your API key and click **Create**.

4. Save your API key to a secure location that enables you to pass it to your code.

5. Import the library:

   ```typescript
   import { createApiClient } from '@neondatabase/api-client';
   ```

6. Create an instance of the API client by calling the `createApiClient` function:

    ```typescript
    const apiClient = createApiClient({
      apiKey: 'your-api-key',
    });
    ```

7. Use the `apiClient` instance to make API calls. For example:

    ```typescript
    const response = await apiClient.listProjects({});
    console.log(response);
    ```

## API Reference
https://api-docs.neon.tech/

## Configuration
Since the client is based on `axios` library, `createApiClient` additionally accepts [axios request options](https://axios-http.com/docs/req_config).

## License

The `@neondatabase/api-client` library is licensed under the MIT License. For more information, see the [LICENSE](./LICENSE) file.
