export * from './api.gen';

import { Api, type ApiConfig } from './api.gen';

export const createApiClient = <SecurityDataType = unknown>(
  config: ApiConfig<SecurityDataType> & {
    apiKey: string | null;
  },
) =>
  new Api<SecurityDataType>({
    ...config,
    headers: {
      ...config.headers,
      ...(config.apiKey && {
        Authorization: `Bearer ${config.apiKey}`,
      }),
    },
  });
